git-mergetool--lib.sh 6.37 KB
Newer Older
1
#!/bin/sh
2
# git-mergetool--lib is a library for common merge tool functions
3 4
MERGE_TOOLS_DIR=$(git --exec-path)/mergetools

5 6 7 8 9 10 11 12 13
diff_mode() {
	test "$TOOL_MODE" = diff
}

merge_mode() {
	test "$TOOL_MODE" = merge
}

translate_merge_tool_path () {
14
	echo "$1"
15 16 17
}

check_unchanged () {
18 19
	if test "$MERGED" -nt "$BACKUP"
	then
20 21
		status=0
	else
22 23
		while true
		do
24 25
			echo "$MERGED seems unchanged."
			printf "Was the merge successful? [y/n] "
26
			read answer || return 1
27 28 29 30 31 32 33 34
			case "$answer" in
			y*|Y*) status=0; break ;;
			n*|N*) status=1; break ;;
			esac
		done
	fi
}

35 36 37 38 39 40 41 42 43
valid_tool_config () {
	if test -n "$(get_merge_tool_cmd "$1")"
	then
		return 0
	else
		return 1
	fi
}

44
valid_tool () {
45 46 47 48
	setup_tool "$1" || valid_tool_config "$1"
}

setup_tool () {
49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68
	tool="$1"

	# Fallback definitions, to be overriden by tools.
	can_merge () {
		return 0
	}

	can_diff () {
		return 0
	}

	diff_cmd () {
		status=1
		return $status
	}

	merge_cmd () {
		status=1
		return $status
	}
69

70 71 72 73 74
	translate_merge_tool_path () {
		echo "$1"
	}

	if ! test -f "$MERGE_TOOLS_DIR/$tool"
75
	then
76 77 78 79 80
		# Use a special return code for this case since we want to
		# source "defaults" even when an explicit tool path is
		# configured since the user can use that to override the
		# default path in the scriptlet.
		return 2
81 82 83
	fi

	# Load the redefined functions
84
	. "$MERGE_TOOLS_DIR/$tool"
85 86 87 88

	if merge_mode && ! can_merge
	then
		echo "error: '$tool' can not be used to resolve merges" >&2
89
		return 1
90 91 92
	elif diff_mode && ! can_diff
	then
		echo "error: '$tool' can only be used to resolve merges" >&2
93
		return 1
94 95
	fi
	return 0
96 97 98
}

get_merge_tool_cmd () {
99
	# Prints the custom command for a merge tool
100
	merge_tool="$1"
101 102
	if diff_mode
	then
103
		echo "$(git config difftool.$merge_tool.cmd ||
104
			git config mergetool.$merge_tool.cmd)"
105 106 107
	else
		echo "$(git config mergetool.$merge_tool.cmd)"
	fi
108 109
}

110
# Entry point for running tools
111
run_merge_tool () {
112 113 114 115 116
	# If GIT_PREFIX is empty then we cannot use it in tools
	# that expect to be able to chdir() to its value.
	GIT_PREFIX=${GIT_PREFIX:-.}
	export GIT_PREFIX

117
	merge_tool_path="$(get_merge_tool_path "$1")" || exit
118 119 120
	base_present="$2"
	status=0

121 122
	# Bring tool-specific functions into scope
	setup_tool "$1"
123 124 125 126 127 128 129 130 131 132 133 134 135
	exitcode=$?
	case $exitcode in
	0)
		:
		;;
	2)
		# The configured tool is not a built-in tool.
		test -n "$merge_tool_path" || return 1
		;;
	*)
		return $exitcode
		;;
	esac
136 137 138

	if merge_mode
	then
139
		run_merge_cmd "$1"
140
	else
141
		run_diff_cmd "$1"
142
	fi
143 144 145
	return $status
}

146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181
# Run a either a configured or built-in diff tool
run_diff_cmd () {
	merge_tool_cmd="$(get_merge_tool_cmd "$1")"
	if test -n "$merge_tool_cmd"
	then
		( eval $merge_tool_cmd )
		status=$?
		return $status
	else
		diff_cmd "$1"
	fi
}

# Run a either a configured or built-in merge tool
run_merge_cmd () {
	merge_tool_cmd="$(get_merge_tool_cmd "$1")"
	if test -n "$merge_tool_cmd"
	then
		trust_exit_code="$(git config --bool \
			mergetool."$1".trustExitCode || echo false)"
		if test "$trust_exit_code" = "false"
		then
			touch "$BACKUP"
			( eval $merge_tool_cmd )
			status=$?
			check_unchanged
		else
			( eval $merge_tool_cmd )
			status=$?
		fi
		return $status
	else
		merge_cmd "$1"
	fi
}

182
list_merge_tool_candidates () {
183 184
	if merge_mode
	then
185 186 187 188
		tools="tortoisemerge"
	else
		tools="kompare"
	fi
189 190 191 192
	if test -n "$DISPLAY"
	then
		if test -n "$GNOME_DESKTOP_SESSION_ID"
		then
193 194 195 196
			tools="meld opendiff kdiff3 tkdiff xxdiff $tools"
		else
			tools="opendiff kdiff3 tkdiff xxdiff meld $tools"
		fi
197
		tools="$tools gvimdiff diffuse ecmerge p4merge araxis bc3 codecompare"
198
	fi
199 200
	case "${VISUAL:-$EDITOR}" in
	*vim*)
201
		tools="$tools vimdiff emerge"
202 203
		;;
	*)
204
		tools="$tools emerge vimdiff"
205 206
		;;
	esac
207 208
}

209 210 211
show_tool_help () {
	unavailable= available= LF='
'
212
	for i in "$MERGE_TOOLS_DIR"/*
213
	do
214 215
		tool=$(basename "$i")
		setup_tool "$tool" 2>/dev/null || continue
216 217

		merge_tool_path=$(translate_merge_tool_path "$tool")
218 219
		if type "$merge_tool_path" >/dev/null 2>&1
		then
220
			available="$available$tool$LF"
221
		else
222
			unavailable="$unavailable$tool$LF"
223 224
		fi
	done
225 226

	cmd_name=${TOOL_MODE}tool
227 228
	if test -n "$available"
	then
229
		echo "'git $cmd_name --tool=<tool>' may be set to one of the following:"
230 231
		echo "$available" | sort | sed -e 's/^/	/'
	else
232
		echo "No suitable tool for 'git $cmd_name --tool=<tool>' found."
233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248
	fi
	if test -n "$unavailable"
	then
		echo
		echo 'The following tools are valid, but not currently available:'
		echo "$unavailable" | sort | sed -e 's/^/	/'
	fi
	if test -n "$unavailable$available"
	then
		echo
		echo "Some of the tools listed above only work in a windowed"
		echo "environment. If run in a terminal-only session, they will fail."
	fi
	exit 0
}

249 250
guess_merge_tool () {
	list_merge_tool_candidates
251 252 253 254 255 256
	echo >&2 "merge tool candidates: $tools"

	# Loop over each candidate and stop when a valid merge tool is found.
	for i in $tools
	do
		merge_tool_path="$(translate_merge_tool_path "$i")"
257 258
		if type "$merge_tool_path" >/dev/null 2>&1
		then
259 260
			echo "$i"
			return 0
261 262 263
		fi
	done

264 265
	echo >&2 "No known merge resolution program available."
	return 1
266 267 268 269 270
}

get_configured_merge_tool () {
	# Diff mode first tries diff.tool and falls back to merge.tool.
	# Merge mode only checks merge.tool
271 272
	if diff_mode
	then
273 274 275
		merge_tool=$(git config diff.tool || git config merge.tool)
	else
		merge_tool=$(git config merge.tool)
276
	fi
277 278
	if test -n "$merge_tool" && ! valid_tool "$merge_tool"
	then
279 280 281 282
		echo >&2 "git config option $TOOL_MODE.tool set to unknown tool: $merge_tool"
		echo >&2 "Resetting to default..."
		return 1
	fi
283
	echo "$merge_tool"
284 285 286 287
}

get_merge_tool_path () {
	# A merge tool has been set, so verify that it's valid.
288
	merge_tool="$1"
289 290
	if ! valid_tool "$merge_tool"
	then
291 292 293
		echo >&2 "Unknown merge tool $merge_tool"
		exit 1
	fi
294 295
	if diff_mode
	then
296
		merge_tool_path=$(git config difftool."$merge_tool".path ||
297
				  git config mergetool."$merge_tool".path)
298 299
	else
		merge_tool_path=$(git config mergetool."$merge_tool".path)
300
	fi
301 302
	if test -z "$merge_tool_path"
	then
303
		merge_tool_path="$(translate_merge_tool_path "$merge_tool")"
304
	fi
305
	if test -z "$(get_merge_tool_cmd "$merge_tool")" &&
306 307
		! type "$merge_tool_path" >/dev/null 2>&1
	then
308
		echo >&2 "The $TOOL_MODE tool $merge_tool is not available as"\
309
			 "'$merge_tool_path'"
310 311 312 313 314 315 316
		exit 1
	fi
	echo "$merge_tool_path"
}

get_merge_tool () {
	# Check if a merge tool has been configured
317
	merge_tool="$(get_configured_merge_tool)"
318
	# Try to guess an appropriate merge tool if no tool has been set.
319 320
	if test -z "$merge_tool"
	then
321
		merge_tool="$(guess_merge_tool)" || exit
322 323 324
	fi
	echo "$merge_tool"
}